 /**
 * The SortedSet specification.
 * 
 * Project <A HREF = "http://gloss.di.fc.ul.pt/quest/"> Quest</A>.
 * 
 * @author Gloss
 * @version 1.0 - 23/Nov/2012
 **/
 
specification SortedSet[TotalOrder]

  sorts
    SortedSet[Orderable]
    
  constructors
    empty: --> SortedSet[Orderable];
    insert: SortedSet[Orderable] Orderable --> SortedSet[Orderable];
    
  observers
    isEmpty: SortedSet[Orderable];
    isIn: SortedSet[Orderable] Orderable;
    largest: SortedSet[Orderable] -->? Orderable;
    
  domains
    S: SortedSet[Orderable];
    largest(S) if not isEmpty(S);
    
  axioms
    E, F: Orderable; 
    S: SortedSet[Orderable];
    
    isEmpty(empty());
    not isEmpty(insert(S, E));
    
    not isIn(empty(), E);
    isIn(insert(S,E), F) iff E = F or isIn(S, F);
    
    largest(insert(S, E)) = E if isEmpty(S);
    largest(insert(S, E)) = E if not isEmpty(S) and geq(E, largest(S));
    largest(insert(S, E)) = largest(S) if not isEmpty(S) and not geq(E, largest(S));
    
    insert(insert(S, E), F) = insert(S, E) if E = F;
    insert(insert(S, E), F) = insert(insert(S, F), E);
    
end specification
